﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;

namespace DependencyLocate
{
    /// <summary>
    /// 静态工厂承载
    /// </summary>
    public static class FactoryContainer
    {
        public static IFactory.IServicesFactory Factory { get; set; }
        static FactoryContainer()
        {
            //根据config文件中的配置生成相应的工厂实例
            switch (ConfigurationManager.AppSettings["CurrentDBType"])
            {
                case "mssql":
                    Factory = new MsSqlFactory.ServicesFactory();
                    break;
                case "mysql":
                    Factory = null;
                    break;
                default:
                    Factory = new MsSqlFactory.ServicesFactory();
                    break;
            }
        }
    }
}
