﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;



namespace Web.Controllers
{
    public class ActivityRecordController : Controller
    {
        /// <summary>
        /// 自己编写ORM的Action
        /// </summary>
        /// <returns></returns>
        public ActionResult Index()
        {
            int id = int.Parse(Request["Id"]);
            DateTime t1 = DateTime.Now;
            List<Model.All> activityRecords = DependencyLocate.FactoryContainer.Factory.GetActivityRecordServices().SelectWhereId(id);
            ViewData["activityRecords"] = activityRecords;
            DateTime t2 = DateTime.Now;
            TimeSpan timeSpan = t2 - t1;
            ViewData["startTime"] = t1;
            ViewData["endTime"] = t2;
            ViewData["timeSpan"] = timeSpan.TotalMilliseconds;
            return View();
        }

        public ActionResult Form()
        {
            return View();
        }

        /// <summary>
        /// 使用Entity4的Action
        /// </summary>
        /// <returns></returns>
        public ActionResult IndexEntity4()
        {

            int id = int.Parse(Request["Id"]);
            DateTime t1 = DateTime.Now;
            List<MsSqlModel.All> activityRecords = new List<MsSqlModel.All>();
            activityRecords = DependencyLocate.FactoryContainer.Factory.GetActivityRecordServices().SelectWhereIdEntity4(id);
            ViewData["activityRecords"] = activityRecords;
            DateTime t2 = DateTime.Now;
            TimeSpan timeSpan = t2 - t1;
            ViewData["startTime"] = t1;
            ViewData["endTime"] = t2;
            ViewData["timeSpan"] = timeSpan.TotalMilliseconds;
            System.Web.Helpers.WebCache.Set("activityRecords", activityRecords, 20);

            return View();
        }

        public ActionResult FormEntity4()
        {
            return View();
        }

        /// <summary>
        /// 使用Cache的Action
        /// </summary>
        /// <returns></returns>
        public ActionResult IndexCache()
        {
            int id = int.Parse(Request["Id"]);
            DateTime t1 = DateTime.Now;
            List<MsSqlModel.All> activityRecords = new List<MsSqlModel.All>();
            //使用缓存
            activityRecords = System.Web.Helpers.WebCache.Get("activityRecords");
            if (activityRecords == null)
            {
                activityRecords = DependencyLocate.FactoryContainer.Factory.GetActivityRecordServices().SelectWhereIdEntity4(id);
                System.Web.Helpers.WebCache.Set("activityRecords", activityRecords, 20, true);
            }
            ViewData["activityRecords"] = activityRecords;
            DateTime t2 = DateTime.Now;
            TimeSpan timeSpan = t2 - t1;
            ViewData["startTime"] = t1;
            ViewData["endTime"] = t2;
            ViewData["timeSpan"] = timeSpan.TotalMilliseconds;
            System.Web.Helpers.WebCache.Set("activityRecords", activityRecords, 20);
            return View();
        }
        public ActionResult FormCache()
        {
            return View();
        }
    }
}
